#! /usr/bin/perl

use lib '../sd';
use lib '../..';
use dbManWeb;

local $q = new dbManWeb 'dbManWeb - SQL prompt';

$q->footer('<A HREF="./?'.$q->req.'">Back to main menu</A>');

$q->startform;
$q->reqform;
$q->add('<SMALL>Please enter SQL query:</SMALL>');  $q->br;
$q->textarea(-name => 'sql', -rows => 8, -columns => 100);  $q->br;  
$q->submit('Execute SQL');  $q->space;
$q->checkbox(-name => 'double', -label => ' Two columns output');  $q->space;
$q->checkbox(-name => 'small', -checked => 1, -label => ' Small font in table');
$q->space; 
$q->checkbox(-name => 'count', -label => ' Count lines');
$q->p;  $q->endform;

my $sql = $q->param('sql'); 
$sql =~ s/^\s+//g;  $sql =~ s/\s+$//g;  $sql =~ s/\s*;$//g;
if ($q->param('Execute SQL') and $sql) {
	$q->hr; $q->br;
	$q->small('<TT>'.$q->param('sql').'</TT>');  $q->p;
	my $ok = undef;
	if ($q->param('sql') =~ /^(select|describe|show)\s+/) {
		$sql = $q->{ndbi}->ndbd_describe($1) 
			if $sql =~ /^describe\s+(.*)/i;
		my $sth = $q->{ndbi}->prepare($sql);
		$ok = $sth->execute();
		if (defined $ok) {
			my $ref = $sth->fetchall_arrayref();
			my @nameres = ();
			if (defined (my $rf = $sth->{NAME})) 
				{ @nameres = @$rf; }
			else {
				@nameres = ();
				for ($sth->{NUM_OF_FIELDS}) 
					{ push @nameres,' '; }
			}
			$sth->finish();
			my $count = $q->param('count');
			my $i = 0;  my $col = scalar @nameres;
			unshift @nameres,'&nbsp;' if $count;
			for (@$ref) {
				++$i;
				$_ = [ ($count ? 
					({align=>'right'},"<FONT SIZE=1 COLOR=green>$i</FONT>") : ()), 
				map { 
					defined $_ ? $_ : 'NULL';  
					$_ =~ s/\r/\\r/; 
					$q->looks_like_number ($_) ? 
						({align => 'right'},$_) 
						: $_;
				} @$_ ];
			}
			if ($q->param('double')) {
				$ref = $q->double($ref);
				@nameres = (@nameres,' &nbsp; ',@nameres);
			}
			my $fnc = $q->param('small')?'table_small':'table';
			$q->$fnc(col_headings_color => '#C0C0C0', 
				col_headings => [ @nameres ], 
				rows => $ref);
			$q->p;
			$q->desc(sprintf("[%i row%s of %i field%s returned.]",$i,(($i > 1)?'s':''),$col,(($col > 1)?'s':'')));
		}
	} else {
		if ($ok = $q->{ndbi}->do($sql)) {
			$q->add('OK, SQL query executed and database returns no error.');
			$q->p;
		}
	}

	unless ($ok) {
		$q->font({-color=>'red'},'Error in SQL query:<BR>'.$q->{ndbi}->state.' '.$q->{ndbi}->errstr); $q->p;
	}
}
